﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;

namespace FlexGridIntro
{
    public class Person
    {
        internal static string[] Countries = "China|India|United States|Indonesia|Brazil|Pakistan|Bangladesh|Nigeria|Russia|Japan|Mexico|Philippines|Vietnam|Germany|Ethiopia|Egypt|Iran|Turkey|Congo|France|Thailand|United Kingdom|Italy|Myanmar".Split('|');

        #region ctor

        public Person()
        {
        }

        #endregion

        #region Object Model

        public int ID { get; set; }
        //public string Name { get { return string.Format("{0} {1}", First, Last); } }
        //public string Country { get { return Countries[CountryID]; } }
        public int CountryID { get; set; }
        public bool Active { get; set; }

        //[Required]
        //[RegularExpression(pattern: "^[a-zA-Z0-9]{4,10}$", ErrorMessage = "First Name should be between 4-10 character")]
        public string First { get; set; }
        //[Required, RegularExpression(pattern: "^[a-zA-Z0-9{4,10}$", ErrorMessage = "Last Name should be between 4-10 character")]
        public string Last { get; set; }
        public int Sales { get; set; }
        public DateTime Hired { get; set; }



        #endregion
    }

    public class SampleData
    {
        private static Random _rnd = new Random();
        private static string[] _firstNames = "Andy|Ben|Charlie|Dan|Ed|Fred|Gil|Herb|Jack|Karl|Larry|Mark|Noah|Oprah|Paul|Quince|Rich|Steve|Ted|Ulrich|Vic|Xavier|Zeb".Split('|');
        private static string[] _lastNames = "Ambers|Bishop|Cole|Danson|Evers|Frommer|Griswold|Heath|Jammers|Krause|Lehman|Myers|Neiman|Orsted|Paulson|Quaid|Richards|Stevens|Trask|Ulam".Split('|');

        private static string GetString(string[] arr)
        {
            return arr[_rnd.Next(arr.Length)];
        }

        public static IEnumerable<Person> GetData(int count)
        {
            var list = Enumerable.Range(0, count).Select(i =>
            {
                return new Person()
                {
                    ID = i,
                    First = $"{_rnd.Next(100, 999).ToString()}-{_rnd.Next(10, 99).ToString()}-{_rnd.Next(1000, 9999).ToString()}" ,
                    Last = _lastNames[i % _lastNames.Length],
                    CountryID = i % 8,
                    Hired = DateTime.Today.AddDays(-_rnd.Next(0, 60)),
                    Sales = _rnd.Next(1000, 999999),
                    Active = false
                };
            });
            return list;
        }
    }
    public class ModelObj
    {
        public string Str { get; set; }
        public List<Person> Persons { get; set; }
    }


}
